const libs = `${process.cwd()}/libs`;
const log = require(`${libs}/log`)(module);
const execQuery = require(`${libs}/db/query_exec`);

/**
 * Middleware that executes a query defined by a squel object in req.sql
 * @param  {Object}   req  [description]
 * @param  {Object}   res  [description]
 * @param  {Function} next [description]
 */
function query(req, res, next) {
    log.debug(req.sql);
    execQuery(req.sql.text, req.sql.values).then((result) => {
        log.debug(result);
        req.result = result;
        next();
    }, (error) => {
        next(error);
    });
}

module.exports = query;
